Index: moodle/lib/navigationlib.php
--- moodle/lib/navigationlib.php Base (1.86)
+++ moodle/lib/navigationlib.php Locally Modified (Based On 1.86)
@@ -2260,153 +1611,98 @@
         } else if ($this->hasitems !== false) {
             return true;
         }
-        $this->page->navigation->initialise();
+        $this->page->navigation->initialise($this->page);
 
         $activenodefound = ($this->page->navigation->contains_active_node() ||
-                            $this->page->settingsnav->contains_active_node() ||
-                            $this->page->navigation->reiterate_active_nodes(URL_MATCH_BASE) ||
-                            $this->page->settingsnav->reiterate_active_nodes(URL_MATCH_BASE));
+                            $this->page->settingsnav->contains_active_node());
 
-        $outcome = (count($this->page->navbar->children)>0 || (!$this->ignoreactive && $activenodefound));
+        $outcome = (count($this->children)>0 || (!$this->ignoreactive && $activenodefound));
         $this->hasitems = $outcome;
         return $outcome;
     }
 
+    /**
+     * Turn on/off ignore active
+     *
+     * @param bool $setting
+     */
     public function ignore_active($setting=true) {
         $this->ignoreactive = ($setting);
     }
-
     /**
-     * Generate the XHTML content for the navbar and return it
+     * Returns an array of navigation_node's that make up the navbar.
      *
-     * We are lucky in that we can rely on PAGE->navigation for the structure
-     * we simply need to look for the `active` path through the tree. We make this
-     * easier by calling {@link strip_down_to_final_active()}.
-     *
-     * This function should in the future be refactored to work with a copy of the
-     * PAGE->navigation object and strip it down to just this the active nodes using
-     * a function that could be written again navigation_node called something like
-     * strip_inactive_nodes(). I wrote this originally but currently the navigation
-     * object is managed via references.
-     *
-     * @return string XHTML navbar content
+     * @return array
      */
-    public function content() {
-        if ($this->duringinstall) {
-            return '';
-        }
-
+    public function get_items() {
+        $items = array();
         // Make sure that navigation is initialised
         if (!$this->has_items()) {
-            return '';
+            return $items;
         }
+        if ($this->items !== null) {
+            return $this->items;
+        }
 
-        if ($this->content !== null) {
-            return $this->content;
+        if (count($this->children) > 0) {
+            // Add the custom children
+            $items = array_reverse($this->children);
         }
 
-        // For screen readers
-        $output = get_accesshide(get_string('youarehere','access'), 'h2').html_writer::start_tag('ul');
+        $navigationactivenode = $this->page->navigation->find_active_node();
+        $settingsactivenode = $this->page->settingsnav->find_active_node();
 
-        $navigationactive = $this->page->navigation->contains_active_node();
-        $settingsactive = $this->page->settingsnav->contains_active_node();
-
         // Check if navigation contains the active node
         if (!$this->ignoreactive) {
-            if ($navigationactive && $settingsactive) {
+            
+            if ($navigationactivenode && $settingsactivenode) {
                 // Parse a combined navigation tree
-                $output .= $this->parse_branch_to_html($this->page->navigation->children, true, true);
-                $activenode = $this->page->settingsnav->find_active_node();
-                if ($activenode) {
-                    $output .= $this->parse_branch_to_html(array($activenode), false);
+                while ($settingsactivenode && $settingsactivenode->parent !== null) {
+                    if (!$settingsactivenode->mainnavonly) {
+                        $items[] = $settingsactivenode;
                 }
-            } else if ($navigationactive) {
-                // Parse the navigation tree to get the active node
-                $output .= $this->parse_branch_to_html($this->page->navigation->children, true);
-            } else if ($settingsactive) {
-                // Parse the settings navigation to get the active node
-                $output .= $this->parse_branch_to_html($this->page->settingsnav->children, true);
+                    $settingsactivenode = $settingsactivenode->parent;
             }
-        } else {
-            $output .= $this->parse_branch_to_html($this, true);
+                // Removes the first node from the settings (root node) from the list
+                array_pop($items);
+                while ($navigationactivenode && $navigationactivenode->parent !== null) {
+                    if (!$navigationactivenode->mainnavonly) {
+                        $items[] = $navigationactivenode;
         }
-
-        if (!empty($this->children)) {
-            // Add the custom children
-            $output .= $this->parse_branch_to_html($this->children, false, false);
+                    $navigationactivenode = $navigationactivenode->parent;
         }
-
-        $output .= html_writer::end_tag('ul');
-        $this->content = $output;
-        return $output;
+            } else if ($navigationactivenode) {
+                // Parse the navigation tree to get the active node
+                while ($navigationactivenode && $navigationactivenode->parent !== null) {
+                    if (!$navigationactivenode->mainnavonly) {
+                        $items[] = $navigationactivenode;
     }
-    /**
-     * This function converts an array of nodes into XHTML for the navbar
-     *
-     * @param array $navarray
-     * @param bool $firstnode
-     * @return string HTML
-     */
-    protected function parse_branch_to_html($navarray, $firstnode=true, $morecoming=false) {
-        global $CFG;
-        $separator = get_separator();
-        $output = '';
-        if ($firstnode===true) {
-            // If this is the first node add the class first and display the
-            // navbar properties (normally sitename)
-            $output .= html_writer::tag('li', parent::content(true), array('class'=>'first'));
+                    $navigationactivenode = $navigationactivenode->parent;
         }
-        $count = 0;
-        if (!is_array($navarray)) {
-            return $output;
+            } else if ($settingsactivenode) {
+                // Parse the settings navigation to get the active node
+                while ($settingsactivenode && $settingsactivenode->parent !== null) {
+                    if (!$settingsactivenode->mainnavonly) {
+                        $items[] = $settingsactivenode;
         }
-        // Iterate the navarray and display each node
-        while (count($navarray)>0) {
-            // Sanity check make sure we don't display WAY too much information
-            // on the navbar. If we get to 20 items just stop!
-            $count++;
-            if ($count>20) {
-                // Maximum number of nodes in the navigation branch
-                return $output;
+                    $settingsactivenode = $settingsactivenode->parent;
             }
-            $child = false;
-            // Iterate the nodes in navarray and find the active node
-            foreach ($navarray as $tempchild) {
-                if ($tempchild->isactive || $tempchild->contains_active_node()) {
-                    $child = $tempchild;
-                    // We've got the first child we can break out of this foreach
-                    break;
                 }
             }
-            // Check if we found the child
-            if ($child===false || $child->mainnavonly) {
-                // Set navarray to an empty array so that we complete the while
-                $navarray = array();
-            } else {
-                // We found an/the active node, set navarray to it's children so that
-                // we come back through this while with the children of the active node
-                $navarray = $child->children;
-                // If there are not more arrays being processed after this AND this is the last element
-                // then we want to set the action to null so that it is not used
-                if (empty($this->children) && !$morecoming && (!$child->contains_active_node() || ($child->find_active_node()==false || $child->find_active_node()->mainnavonly))) {
-                    $oldaction = $child->action;
-                    $child->action = null;
-                }
-                if ($child->type !== navigation_node::TYPE_CATEGORY || !isset($CFG->navshowcategories) || !empty($CFG->navshowcategories)) {
-                    // Now display the node
-                    $output .= html_writer::tag('li', $separator.' '.$child->content(true));
-                }
-                if (isset($oldaction)) {
-                    $child->action = $oldaction;
-                }
-            }
-        }
 
-        // XHTML
-        return $output;
+        $items[] = new navigation_node(array(
+            'text'=>$this->page->navigation->text,
+            'shorttext'=>$this->page->navigation->shorttext,
+            'key'=>$this->page->navigation->key,
+            'action'=>$this->page->navigation->action
+        ));
+
+        $this->items = array_reverse($items);
+        return $this->items;
     }
+
     /**
-     * Add a new node to the navbar, overrides parent::add
+     * Add a new navigation_node to the navbar, overrides parent::add
      *
      * This function overrides {@link navigation_node::add()} so that we can change
      * the way nodes get added to allow us to simply call add and have the node added to the
@@ -2418,25 +1714,43 @@
      * @param string|int $key
      * @param string $shorttext
      * @param string $icon
-     * @return string|int Identifier for this particular node
+     * @return navigation_node
      */
     public function add($text, $action=null, $type=self::TYPE_CUSTOM, $shorttext=null, $key=null, pix_icon $icon=null) {
-        // Check if there are any keys in the objects keys array
-        if (count($this->keys)===0) {
-            // If there are no keys then we can use the add method
-            $key = parent::add($text, $action, $type, $shorttext, $key, $icon);
-        } else {
-            $key = $this->add_to_path($this->keys, $key, $text, $shorttext, $type, $action, $icon);
+        if ($this->content !== null) {
+            debugging('Nav bar items must be printed before $OUTPUT->header() has been called', DEBUG_DEVELOPER);
         }
-        $this->keys[] = $key;
-        $child = $this->get_by_path($this->keys);
-        if ($child!==false) {
-            // This ensure that the child will be shown
-            $child->make_active();
+        
+        // Properties array used when creating the new navigation node
+        $itemarray = array(
+            'text' => $text,
+            'type' => $type
+        );
+        // Set the action if one was provided
+        if ($action!==null) {
+            $itemarray['action'] = $action;
         }
-        return $key;
+        // Set the shorttext if one was provided
+        if ($shorttext!==null) {
+            $itemarray['shorttext'] = $shorttext;
     }
+        // Set the icon if one was provided
+        if ($icon!==null) {
+            $itemarray['icon'] = $icon;
 }
+        // Default the key to the number of children if not provided
+        if ($key === null) {
+            $key = count($this->children);
+        }
+        // Set the key
+        $itemarray['key'] = $key;
+        // Set the parent to this node
+        $itemarray['parent'] = $this;
+        // Add the child using the navigation_node_collections add method
+        $this->children[] = new navigation_node($itemarray);
+        return $this;
+    }
+}
 
 /**
  * Class used to manage the settings option for the current page
@@ -2452,14 +1766,16 @@
 class settings_navigation extends navigation_node {
     /** @var stdClass */
     protected $context;
-    /** @var cache */
+    /** @var navigation_cache */
     protected $cache;
-    /** @var page object */
+    /** @var moodle_page */
     protected $page;
-    /** @var adminsection string */
+    /** @var string */
     protected $adminsection;
     /**
      * Sets up the object with basic settings and preparse it for use
+     * 
+     * @param moodle_page $page
      */
     public function __construct(moodle_page &$page) {
         if (during_initial_install()) {
@@ -2471,12 +1787,15 @@
         $this->page->navigation->initialise();
         // Initialise the navigation cache
         $this->cache = new navigation_cache(NAVIGATION_CACHE_NAME);
+        $this->children = new navigation_node_collection();
     }
     /**
      * Initialise the settings navigation based on the current context
      *
      * This function initialises the settings navigation tree for a given context
      * by calling supporting functions to generate major parts of the tree.
+     *
+     * @global moodle_database $DB
      */
     public function initialise() {
         global $DB;
@@ -2520,13 +1839,13 @@
                 break;
         }
 
-        $settingskey = $this->load_user_settings($this->page->course->id);
-        $adminkey = $this->load_administration_settings();
+        $settings = $this->load_user_settings($this->page->course->id);
+        $admin = $this->load_administration_settings();
 
-        if ($context->contextlevel == CONTEXT_SYSTEM) {
-            $this->get($adminkey)->forceopen = true;
-        } else if ($context->contextlevel == CONTEXT_USER) {
-            $this->get($settingskey)->forceopen = true;
+        if ($context->contextlevel == CONTEXT_SYSTEM && $admin) {
+            $admin->force_open();
+        } else if ($context->contextlevel == CONTEXT_USER && $settings) {
+            $settings->force_open();
         }
 
         // Check if the user is currently logged in as another user
@@ -2539,12 +1858,13 @@
         }
 
         // Make sure the first child doesnt have proceed with hr set to true
-        reset($this->children);
-        current($this->children)->preceedwithhr = false;
 
-        $this->remove_empty_root_branches();
-        $this->respect_forced_open();
+        foreach ($this->children as $key=>$node) {
+            if ($node->nodetype != self::NODETYPE_BRANCH || $node->children->count()===0) {
+                $node->remove();
     }
+        }
+    }
     /**
      * Override the parent function so that we can add preceeding hr's and set a
      * root node class against all first level element
@@ -2558,13 +1878,12 @@
      * @param string|int $key
      * @param int $type
      * @param string $icon
-     * @return sting|int A key that can be used to reference the newly added node
+     * @return navigation_node
      */
     public function add($text, $url=null, $type=null, $shorttext=null, $key=null, pix_icon $icon=null) {
-        $key = parent::add($text, $url, $type, $shorttext, $key, $icon);
-        $this->get($key)->add_class('root_node');
-        $this->get($key)->preceedwithhr = true;
-        return $key;
+        $node = parent::add($text, $url, $type, $shorttext, $key, $icon);
+        $node->add_class('root_node');
+        return $node;
     }
 
     /**
@@ -2577,28 +1896,25 @@
      * @param string|int $key
      * @param int $type
      * @param string $icon
-     * @return sting|int A key that can be used to reference the newly added node
+     * @return navigation_node
      */
     public function prepend($text, $url=null, $type=null, $shorttext=null, $key=null, pix_icon $icon=null) {
-        $key = $this->add($text, $url, $type, $shorttext, $key, $icon);
         $children = $this->children;
-        $this->children = array();
-        $this->children[$key] = array_pop($children);
-        foreach ($children as $k=>$child) {
-            $this->children[$k] = $child;
-            $this->get($k)->add_class('root_node');
-            $this->get($k)->preceedwithhr = true;
+        $this->children = new get_class($children);
+        $node = $this->add($text, $url, $type, $shorttext, $key, $icon);
+        foreach ($children as $child) {
+            $this->children->add($child);
         }
-        return $key;
+        return $node;
     }
     /**
      * Load the site administration tree
      *
      * This function loads the site administration tree by using the lib/adminlib library functions
      *
-     * @param null|navigation_node $referencebranch A reference to a branch in the settings
+     * @param navigation_node $referencebranch A reference to a branch in the settings
      *      navigation tree
-     * @param null|part_of_admin_tree $adminbranch The branch to add, if null generate the admin
+     * @param part_of_admin_tree $adminbranch The branch to add, if null generate the admin
      *      tree and start at the beginning
      * @return mixed A key to access the admin tree by
      */
@@ -2618,22 +1934,23 @@
 
             // Disable the navigation from automatically finding the active node
             navigation_node::$autofindactive = false;
-            $branchkey = $this->add(get_string('administrationsite'), null, self::TYPE_SETTING, null, 'root');
-            $referencebranch = $this->get($branchkey);
+            $referencebranch = $this->add(get_string('administrationsite'), null, self::TYPE_SETTING, null, 'root');
             foreach ($adminroot->children as $adminbranch) {
                 $this->load_administration_settings($referencebranch, $adminbranch);
             }
             navigation_node::$autofindactive = true;
 
             // Use the admin structure to locate the active page
-            if ($current = $adminroot->locate($this->adminsection, true)) {
-                // Get the active node using the path in the active page
-                if ($child = $this->get_by_path(array_reverse($current->path))) {
-                    // Make the node active!
-                    $child->make_active();
+            if (!$this->contains_active_node() && $current = $adminroot->locate($this->adminsection, true)) {
+                $currentnode = $this;
+                while (($pathkey = array_pop($current->path))!==null && $currentnode) {
+                    $currentnode = $currentnode->get($pathkey);
                 }
+                if ($currentnode) {
+                    $currentnode->make_active();
             }
-            return $branchkey;
+            }
+            return $referencebranch;
         } else if ($adminbranch->check_access()) {
             // We have a reference branch that we can access and is not hidden `hurrah`
             // Now we need to display it and any children it may have
@@ -2646,8 +1963,7 @@
             }
 
             // Add the branch
-            $branchkey = $referencebranch->add($adminbranch->visiblename, $url, self::TYPE_SETTING, null, $adminbranch->name, $icon);
-            $reference = $referencebranch->get($branchkey);
+            $reference = $referencebranch->add($adminbranch->visiblename, $url, self::TYPE_SETTING, null, $adminbranch->name, $icon);
 
             if ($adminbranch->is_hidden()) {
                 if (($adminbranch instanceof admin_externalpage || $adminbranch instanceof admin_settingpage) && $adminbranch->name == $this->adminsection) {
@@ -2674,6 +1990,21 @@
     }
 
     /**
+     * Gets a navigation node given an array of keys that represent the path to
+     * the desired node.
+     *
+     * @param array $path
+     * @return navigation_node|false
+     */
+    protected function get_by_path(array $path) {
+        $node = $this->get(array_shift($path));
+        foreach ($path as $key) {
+            $node->get($key);
+        }
+        return $node;
+    }
+
+    /**
      * Generate the list of modules for the given course.
      *
      * The array of resources and activities that can be added to a course is then
@@ -2739,7 +2070,7 @@
      * This function loads the course settings that are available for the user
      *
      * @param bool $forceopen If set to true the course node will be forced open
-     * @return bool|mixed Either false of a key to access the course tree by
+     * @return navigation_node|false
      */
     protected function load_course_settings($forceopen = false) {
         global $CFG, $USER, $SESSION, $OUTPUT;
@@ -2753,9 +2084,10 @@
             return false;
         }
 
-        $coursenodekey = $this->add(get_string('courseadministration'), null, self::TYPE_COURSE, null, 'courseadmin');
-        $coursenode = $this->get($coursenodekey);
-        $coursenode->forceopen = ($forceopen==true);
+        $coursenode = $this->add(get_string('courseadministration'), null, self::TYPE_COURSE, null, 'courseadmin');
+        if ($forceopen) {
+            $coursenode->force_open();
+        }
 
         if (has_capability('moodle/course:update', $coursecontext)) {
             // Add the turn on/off settings
@@ -2785,11 +2117,11 @@
                 }
                 $sections = $this->cache->{'coursesections'.$course->id};
 
-                $addresource = $this->get($this->add(get_string('addresource')));
-                $addactivity = $this->get($this->add(get_string('addactivity')));
+                $addresource = $this->add(get_string('addresource'));
+                $addactivity = $this->add(get_string('addactivity'));
                 if ($formatidentifier!==0) {
-                    $addresource->forceopen = true;
-                    $addactivity->forceopen = true;
+                    $addresource->force_open();
+                    $addactivity->force_open();
                 }
 
                 if (!$this->cache->cached('course'.$course->id.'resources')) {
@@ -2821,7 +2153,7 @@
                         } else {
                             $url->param('add', $value);
                         }
-                        $addresource->get($sectionresources)->add($resource, $url, self::TYPE_SETTING);
+                        $sectionresources->add($resource, $url, self::TYPE_SETTING);
                     }
                     $subbranch = false;
                     foreach ($activities as $activityname=>$activity) {
@@ -2830,7 +2162,7 @@
                             continue;
                         }
                         if (strpos($activity, '--')===0) {
-                            $subbranch = $addactivity->get($sectionactivities)->add(trim($activity, '-'));
+                            $subbranch = $sectionresources->add(trim($activity, '-'));
                             continue;
                         }
                         $url = new moodle_url('/course/mod.php', array('id'=>$course->id, 'sesskey'=>sesskey(), 'section'=>$section->section));
@@ -2842,9 +2174,9 @@
                             $url->param('add', $activityname);
                         }
                         if ($subbranch !== false) {
-                            $addactivity->get($sectionactivities)->get($subbranch)->add($activity, $url, self::TYPE_SETTING);
+                            $subbranch->add($activity, $url, self::TYPE_SETTING);
                         } else {
-                            $addactivity->get($sectionactivities)->add($activity, $url, self::TYPE_SETTING);
+                            $sectionresources->add($activity, $url, self::TYPE_SETTING);
                         }
                     }
                 }
@@ -2910,8 +2242,8 @@
                 $url = new moodle_url('/course/importstudents.php', array('id'=>$course->id));
                 $coursenode->add(get_string('childcourses'), $url, self::TYPE_SETTING, null, null, new pix_icon('i/course', ''));
             } else if (has_capability('moodle/role:assign', $coursecontext)) {
-                $key = $coursenode->add(get_string('childcourses'), null,  self::TYPE_SETTING, null, null, new pix_icon('i/course', ''));
-                $coursenode->get($key)->hidden = true;;
+                $roleassign = $coursenode->add(get_string('childcourses'), null,  self::TYPE_SETTING, null, null, new pix_icon('i/course', ''));
+                $roleassign->hidden = true;
             }
         }
 
@@ -3008,12 +2340,6 @@
             }
         }
 
-        // Link to the user own profile (except guests)
-        if (!isguestuser() and isloggedin()) {
-            $url = new moodle_url('/user/view.php', array('id'=>$USER->id, 'course'=>$course->id));
-            $coursenode->add(get_string('profile'), $url, self::TYPE_SETTING, null, null, new pix_icon('i/user', ''));
-        }
-
         // Switch roles
         $roles = array();
         $assumedrole = $this->in_alternative_role();
@@ -3032,20 +2358,20 @@
             }
         }
         if (is_array($roles) && count($roles)>0) {
-            $switchroleskey = $this->add(get_string('switchroleto'));
+            $switchroles = $this->add(get_string('switchroleto'));
             if ((count($roles)==1 && array_key_exists(0, $roles))|| $assumedrole!==false) {
-                $this->get($switchroleskey)->forceopen = true;
+                $switchroles->force_open();
             }
             $returnurl = $this->page->url;
             $returnurl->param('sesskey', sesskey());
             $SESSION->returnurl = serialize($returnurl);
             foreach ($roles as $key=>$name) {
                 $url = new moodle_url('/course/switchrole.php', array('id'=>$course->id,'sesskey'=>sesskey(), 'switchrole'=>$key, 'returnurl'=>'1'));
-                $this->get($switchroleskey)->add($name, $url, self::TYPE_SETTING, null, $key, new pix_icon('i/roles', ''));
+                $switchroles->add($name, $url, self::TYPE_SETTING, null, $key, new pix_icon('i/roles', ''));
             }
         }
         // Return we are done
-        return $coursenodekey;
+        return $coursenode;
     }
 
     /**
@@ -3057,7 +2383,7 @@
      *
      * For examples mod/forum/lib.php ::: forum_extend_settings_navigation()
      *
-     * @return void|mixed The key to access the module method by
+     * @return navigation_node|false
      */
     protected function load_module_settings() {
         global $CFG;
@@ -3067,9 +2393,8 @@
             $this->page->set_cm($cm, $this->page->course);
         }
 
-        $modulekey = $this->add(get_string($this->page->activityname.'administration', $this->page->activityname));
-        $modulenode = $this->get($modulekey);
-        $modulenode->forceopen = true;
+        $modulenode = $this->add(get_string($this->page->activityname.'administration', $this->page->activityname));
+        $modulenode->force_open();
 
         // Settings for the module
         if (has_capability('moodle/course:manageactivities', $this->page->cm->context)) {
@@ -3104,17 +2429,17 @@
             require_once($file);
         }
         if (!function_exists($function)) {
-            return $modulekey;
+            return $modulenode;
         }
 
         $function($this, $modulenode);
 
         // Remove the module node if there are no children
         if (empty($modulenode->children)) {
-            $this->remove_child($modulekey);
+            $modulenode->remove();
         }
 
-        return $modulekey;
+        return $modulenode;
     }
 
     /**
@@ -3128,6 +2453,7 @@
      * any bright ideas please feel free to intervene.
      *
      * @param int $courseid The course id of the current course
+     * @return navigation_node|false
      */
     protected function load_user_settings($courseid=SITEID) {
         global $USER, $FULLME, $CFG;
@@ -3141,11 +2467,10 @@
         // and the key depends on the current location
         // Default to look at id
         $userkey='id';
-
         if (strpos($FULLME,'/blog/') || strpos($FULLME, $CFG->admin.'/roles/')) {
             // And blog and roles just do thier own thing using `userid`
             $userkey = 'userid';
-        } else if ($this->context->contextlevel >= CONTEXT_COURSECAT && strpos($FULLME, '/message/')===false && strpos($FULLME, '/mod/forum/user')===false) {
+        } else if ($this->context->contextlevel >= CONTEXT_COURSECAT && strpos($FULLME, '/message/')===false && strpos($FULLME, '/mod/forum/user')===false && strpos($FULLME, '/user/editadvanced')===false) {
             // If we have a course context and we are not in message or forum
             // Message and forum both pick the user up from `id`
             $userkey = 'user';
@@ -3153,12 +2478,12 @@
 
         $userid = optional_param($userkey, $USER->id, PARAM_INT);
         if ($userid!=$USER->id) {
-            $userkey = $this->generate_user_settings($courseid, $userid, 'userviewingsettings');
+            $usernode = $this->generate_user_settings($courseid, $userid, 'userviewingsettings');
             $this->generate_user_settings($courseid, $USER->id);
         } else {
-            $userkey = $this->generate_user_settings($courseid, $USER->id);
+            $usernode = $this->generate_user_settings($courseid, $USER->id);
         }
-        return $userkey;
+        return $usernode;
     }
 
     /**
@@ -3168,7 +2493,7 @@
      * @param int $courseid The current course' id
      * @param int $userid The user id to load for
      * @param string $gstitle The string to pass to get_string for the branch title
-     * @return string|int The key to reference this user's settings
+     * @return navigation_node|false
      */
     protected function generate_user_settings($courseid, $userid, $gstitle='usercurrentsettings') {
         global $DB, $CFG, $USER, $SITE;
@@ -3215,8 +2540,7 @@
         $fullname = fullname($user, has_capability('moodle/site:viewfullnames', $this->page->context));
 
         // Add a user setting branch
-        $usersettingskey = $this->add(get_string($gstitle, 'moodle', $fullname));
-        $usersetting = $this->get($usersettingskey);
+        $usersetting = $this->add(get_string($gstitle, 'moodle', $fullname));
         $usersetting->id = 'usersettings';
 
         // Check if the user has been deleted
